(document:surround "/std/frame")

(document:root
	(when loaded
		(woo-catch/message (thunk
			(woo-write "/update-kernel/apt_get_update")))
		(get-flavours)
		(change-flavour)
	)
)

(define (return)
	(frame:replace "/update-kernel")
)

(define (get-flavours)
	(splash-message (_ "Please wait..."))
	(begin-1
		(let ( (flavour_list (woo-list "/update-kernel/get_flavours")))
			(if (string= (form-value "flavours") "")
				(form-update-value "flavours" (woo-get-option (cond-car flavour_list) 'name)))
		)
	(splash-message))
)

(define (change-flavour)
	(if (string= (form-value "flavours") "")
		(form-update-value "flavours" (woo-get-option (cond-car flavour_list) 'name)))

	(let ((data (woo-read-first "/update-kernel/get_available_kernel" 'flavour (flavours-id value))))
		(available-kernel-id value (woo-get-option data 'available_kernel))
		(form-update-activity "update-kernel-btn" (woo-get-option data 'kernel_installation_possible #f))
		(form-update-activity "install-modules-btn" (woo-get-option data 'modules_installation_possible #f))

		(if (and (not (woo-get-option data 'kernel_installation_possible))
			(woo-get-option data 'modules_installation_possible))

			(form-update-value "message" (_ "Latest kernel is already installed on your system."))
			(form-update-value "message" "")
		)
	)

	(get-apt-modules)
)

(define (get-apt-modules)
	(let* ((flavour (form-value "flavours"))
		(modules_list (woo-list "/update-kernel/get_available_modules" 'flavour flavour)))
		(form-update-enum "available_modlist" modules_list)
	)
	(get-apt-inst-modules)
)

(define (get-apt-inst-modules)
	(if (and (not (string= (form-value "flavours") ""))
			(not (string= (form-value "available-kernel") "")))
		(let ((data (woo-read-first "/update-kernel/get_installed_modules_available_in_apt_cache"
			'flavour (flavours-id value))))

			(modlist-id value (woo-get-option data 'inst_avail_mod_list))
		)
	)
)

(define (update-kernel)
	(splash-message (_ "Please wait..."))
	(begin-1
		(if (and (not-empty-string? (available-kernel-id value))
				(form-confirm (_ "Do you really want to update kernel?")))
			(woo-catch/message
				(thunk
					(woo-write "/update-kernel/update_kernel"
						'flavour (flavours-id value)
						'modlist (modlist-id value))
					(form-update-activity "update-kernel-btn" #f)
					(form-update-activity "install-modules-btn" #t)
				)
			)
		)
	(splash-message))
	(change-flavour)
)

(define (install-modules)
	(splash-message (_ "Please wait..."))
	(begin-1
		(if (and (not-empty-string? (modlist-id value))
				(form-confirm (_ "Do you really want to install modules?")))
			(woo-catch/message
				(thunk
					(woo-write "/update-kernel/install_modules"
						'flavour (flavours-id value)
						'modlist (modlist-id value)
					)
				)
			)
		)
	(splash-message))
)

(gridbox columns "5;90;5"
	(spacer)

	(gridbox columns "50;50"
		(vbox
			(gridbox columns "0;80;20" align "top"
				(label text (_ "Available kernel:" ) align "right")
				(document:id available-kernel-id (edit name "available-kernel" alterability #f))
				(document:id flavours-id (combobox name "flavours" enumref "/update-kernel/get_flavours"
					(when changed (change-flavour))))
			)

			(label name "message")

			(gridbox columns "20;20;60" align "bottom"
				(document:id update-kernel-btn-id (button text (_ "Update kernel") name "update-kernel-btn"
					(when clicked (update-kernel))))
				(document:id install-modules-btn-id (button text (_ "Install modules") name "install-modules-btn"
					(when clicked (install-modules))))
				(spacer)
			)
		)

		(gridbox columns "100;0"
			(document:id modlist-id (checklistbox name "available_modlist" header (vector (_ "Available modules"))))
		)
	)

	(spacer)

	(spacer)

	(vbox
		(label)
		(label)
		(label)
		(gridbox columns "90;10" align "bottom"
			(spacer)
			(document:id ok-btn-id (button text (_ "<<  back") name "back-btn" (when clicked (return))))
		)
	)

	(spacer)
)
